<script lang="ts" setup>
import { ref, onMounted } from 'vue';

enum FreeTrialVariant {
  PRIMARY = 'primary',
  ACCENT = 'accent',
  GLEAM = 'gleam',
  STEEL = 'steel',
}

// Define props
const props = defineProps<{
  href: string;
  freeTrialVariant?: string;
}>();

// Setup reactive variables
const ctaVariants = FreeTrialVariant;
const navButton = ref<InstanceType<typeof SlpButton> | null>(null);

// Lifecycle hook
onMounted(() => {
  if (props.freeTrialVariant === FreeTrialVariant.STEEL) {
    for (let i = 1; i <= 2; i++) {
      setTimeout(() => {
        navButton.value?.$el.classList.add('be-nav__nav-button--animate');
        setTimeout(() => {
          navButton.value?.$el.classList.remove('be-nav__nav-button--animate');
        }, 500 * i);
      }, 2000 * i);
    }
  }
});
</script>

<template>
  <!-- eslint-disable dex-data-properties/require-data-ga-attributes -->
  <SlpButton
    ref="navButton"
    variant="primary"
    class="be-nav__nav-button"
    :href="props.href"
    :class="{
      'be-nav__nav-button--accent': props.freeTrialVariant === ctaVariants.ACCENT,
      'be-nav__nav-button--gleam': props.freeTrialVariant === ctaVariants.GLEAM,
      'be-nav__nav-button--steel': props.freeTrialVariant === ctaVariants.STEEL,
    }"
  >
    <slot />
  </SlpButton>
  <!-- eslint-enable dex-data-properties/require-data-ga-attributes -->
</template>

<style lang="scss" scoped>
.be-nav__nav-button {
  transition: background-color 0.1s ease-in-out !important;

  &--steel {
    background: linear-gradient(93.83deg, rgba(0, 0, 0, 1) 7.27%, rgba(0, 0, 0, 1) 105.33%) !important;
    position: relative;
    overflow: hidden;

    &:after {
      content: '';
      position: absolute;
      top: 0;
      left: -200%;
      width: 200%;
      height: 100%;
      transform: skewX(-20deg);
      background-image: linear-gradient(to right, transparent, rgba(255, 255, 255, 0.5), transparent);
    }

    &:hover {
      background-color: $color-primary-300 !important;
      color: $color-primary-300 !important;
    }

    &:hover:after {
      animation: shine 0.8s ease-in-out;
    }
  }

  &--accent {
    background-color: $color-accent-300 !important;
    color: $color-primary-300 !important;
    border-color: $color-accent-300 !important;

    &:hover {
      background-color: $color-primary-300 !important;
      color: $color-accent-300 !important;
    }
  }

  &--animate {
    &:after {
      animation: shine 1s ease-in-out;
    }
  }

  &--gleam {
    background: linear-gradient(
      93.83deg,
      rgba(199, 177, 254, 0.75) 7.27%,
      rgba(255, 212, 216, 0.75) 105.33%
    ) !important;
    color: $color-primary-200 !important;
    border: none !important;
    position: relative;
    overflow: hidden;

    &:after {
      content: '';
      position: absolute;
      top: 0;
      left: -200%;
      width: 200%;
      height: 100%;
      transform: skewX(-20deg);
      background-image: linear-gradient(to right, transparent, rgba(255, 255, 255, 0.5), transparent);
    }

    &:hover:after {
      animation: shine 0.8s ease-in-out;
    }
  }
}

@keyframes shine {
  100% {
    left: 200%;
  }
}
</style>
